function GenOptPlots()

beta = [];
alpha = [];
load('LogRateData_6D.mat');

Clog_mac = Clog_macusf + Clog_maccsf;
Clog_pic = Clog_picusf + Clog_piccsf;

ro_i = linspace(-10,20,100)';
ro1_i = linspace(-10,20,100)';
Clog_mac_smooth = zeros(length(ro_i),length(beta),length(alpha),length(toudB),length(LambdaPrime),length(P_dBm));
Clog_pic_smooth = zeros(length(ro1_i),length(beta),length(alpha),length(toudB),length(LambdaPrime),length(P_dBm));
for i = 1:length(P_dBm)
    for j = 1:length(LambdaPrime)
        for k = 1:length(toudB)
            for l = 1:length(alpha)
                for m = 1:length(beta)
                    Clog_mac_smooth(:,m,l,k,j,i) = spline(rodB,Clog_mac(:,m,l,k,j,i),ro_i);
                    Clog_pic_smooth(:,m,l,k,j,i) = spline(ro1dB,Clog_pic(:,m,l,k,j,i),ro1_i);
                end
            end
        end
    end
end

% Optimize \rho
[Clog_mac_ro_opt, idx_ro_opt] = max(Clog_mac_smooth);
Clog_mac_ro_opt = squeeze(Clog_mac_ro_opt);
% idx_ro_opt = squeeze(idx_ro_opt);

% Optimize \rho\prime
[Clog_pic_ro1_opt, idx_ro1_opt] = max(Clog_pic_smooth);
Clog_pic_ro1_opt = squeeze(Clog_pic_ro1_opt);
% idx_ro1_opt = squeeze(idx_ro1_opt);

Clog_ro_ro1_opt = Clog_mac_ro_opt + Clog_pic_ro1_opt;

% Optimize \Beta
[Clog_beta_opt, idx_beta_opt] = max(Clog_ro_ro1_opt);
Clog_beta_opt = squeeze(Clog_beta_opt);
idx_beta_opt = squeeze(idx_beta_opt);

alpha_smooth = linspace(min(alpha),max(alpha),100);
Clog_smooth = zeros(length(alpha_smooth),length(toudB),length(LambdaPrime),length(P_dBm));
for i = 1:length(P_dBm)
    for j = 1:length(LambdaPrime)
        for k = 1:length(toudB)
            Clog_smooth(:,k,j,i) = interp1(alpha,Clog_beta_opt(:,k,j,i),alpha_smooth);
        end
    end
end

% Optimize \alpha
[Clog_alpha_opt, idx_alpha_opt] = max(Clog_smooth);
Clog_alpha_opt = squeeze(Clog_alpha_opt);
idx_alpha_opt = squeeze(idx_alpha_opt);
alpha_opt = alpha_smooth(idx_alpha_opt);

% Maximum C_log v/s PBS density plots
figure(1);
clf;
plot(LambdaPrime(:), Clog_alpha_opt(1,:,1),'-s');
hold on;
plot(LambdaPrime(:), Clog_alpha_opt(2,:,1),'-ro');
plot(LambdaPrime(:), Clog_alpha_opt(3,:,1),'-gv');
plot(LambdaPrime(:), Clog_alpha_opt(1,:,2),'--s');
plot(LambdaPrime(:), Clog_alpha_opt(2,:,2),'r--o');
plot(LambdaPrime(:), Clog_alpha_opt(3,:,2),'g--v');
hold off;
xlabel('PBS density / MBS desity (\lambda\prime/\lambda)');
ylabel('maximum C_{log }');
legend('\tau = 0 dB','\tau = 6 dB','\tau = 12 dB','Location','NorthWest');
H = annotation('ellipse',[0.486 0.536 0.048 0.24]);
set(H);
H = annotation('textbox',[0.428 0.779 0.181 0.055]);
set(H,'string','P_{pic} = 30 dBm','EdgeColor','none');
H = annotation('ellipse',[0.577 0.255 0.048 0.174]);
set(H);
H = annotation('textbox',[0.516 0.434 0.181 0.055]);
set(H,'string','P_{pic} = 10 dBm','EdgeColor','none');

% Optimum alpha v/s PBS density plots
figure(2);
clf;
plot(LambdaPrime(:), alpha_opt(1,:,1),'-s');
hold on;
plot(LambdaPrime(:), alpha_opt(2,:,1),'-ro');
plot(LambdaPrime(:), alpha_opt(3,:,1),'-gv');
plot(LambdaPrime(:), alpha_opt(1,:,2),'--s');
plot(LambdaPrime(:), alpha_opt(2,:,2),'r--o');
plot(LambdaPrime(:), alpha_opt(3,:,2),'g--v');
hold off;
xlabel('PBS density / MBS desity (\lambda\prime/\lambda)');
ylabel('optimum  \alpha');
legend('\tau = 0 dB','\tau = 6 dB','\tau = 12 dB','Location','NorthWest');
H = annotation('ellipse',[0.486 0.536 0.048 0.24]);
set(H);
H = annotation('textbox',[0.428 0.779 0.181 0.055]);
set(H,'string','P_{pic} = 30 dBm','EdgeColor','none');
H = annotation('ellipse',[0.577 0.255 0.048 0.174]);
set(H);
H = annotation('textbox',[0.516 0.434 0.181 0.055]);
set(H,'string','P_{pic} = 10 dBm','EdgeColor','none');
ylim([0 1]);

end